function bmpToVHDL( BITMAP_FILENAME, OUTPUT_FILENAME )
%BMPTOVHDL 	This function takes a bmp-file input and produces an output file that can be read by
%          	the VHDL testbenches

%   The loops are split in two so that it doesnt add an empty line at 
%	after the last pixel.

%   Please use OUTPUT_FILENAME "'something'vhdl". You choose 'something, and add vhdl behind.
%   This is because the testbench looks for files with the vhdl suffix. In the testbench you
%   just use 'something' as the input_file.

%EXAMPLE  	bmpToVHDL('in.bmp', 'outvhdl'); 
%
%			Where 'in' is a bitmap file, and 'outvhdl' becomes the vhdl testbench input.
%			I use 'out' as the file name in the testbench.


a = imread(BITMAP_FILENAME);

fid = fopen(OUTPUT_FILENAME, 'w');

for i = 1:1:1079
    for j = 1:1:1920
        if (a(i,j,1) < 16) 
            fprintf(fid,'%X%X', 0,a(i,j,1));
        else
            fprintf(fid,'%X', a(i,j,1));
        end
        if (a(i,j,2) < 16) 
            fprintf(fid,'%X%X', 0,a(i,j,2));
        else
            fprintf(fid,'%X', a(i,j,2));
        end
        if (a(i,j,3) < 16) 
            fprintf(fid,'%X%X\n', 0,a(i,j,3));
        else
            fprintf(fid,'%X\n', a(i,j,3));
        end
    end
end

for j = 1:1:1919
    if (a(1080,j,1) < 16) 
        fprintf(fid,'%X%X', 0,a(1080,j,1));
    else
        fprintf(fid,'%X', a(1080,j,1));
    end
    if (a(1080,j,2) < 16) 
        fprintf(fid,'%X%X', 0,a(1080,j,2));
    else
        fprintf(fid,'%X', a(1080,j,2));
    end
    if (a(1080,j,3) < 16) 
        fprintf(fid,'%X%X\n', 0,a(1080,j,3));
    else
        fprintf(fid,'%X\n', a(1080,j,3));
    end
end

    if (a(1080,1920,1) < 16)
        fprintf(fid,'%X%X', 0,a(1080,1920,1));
    else
        fprintf(fid,'%X', a(1080,1920,1));
    end
    if (a(1080,1920,2) < 16) 
        fprintf(fid,'%X%X', 0,a(1080,1920,2));
    else
        fprintf(fid,'%X', a(1080,1920,2));
    end
    if (a(1080,1920,3) < 16) 
        fprintf(fid,'%X%X', 0,a(1080,1920,3));
    else
        fprintf(fid,'%X', a(1080,1920,3));
    end

fclose(fid);

end