#ifndef CACHE_H
#define CACHE_H

template <const int T>
class cache{
public:
	cache();
	void get_a(unsigned char *x);
	void get_b(unsigned char *x);
	void get_c(unsigned char *x);
	void get_d(unsigned char *x);
	void get_e(unsigned char *x);
	void get_f(unsigned char *x);
	void get_g(unsigned char *x);
	void get_h(unsigned char *x);
	void get_i(unsigned char *x);
	void get_x(unsigned char *x);
	void write_x(unsigned char *x);
	void push(unsigned char *x);

private:
	unsigned char * reg_p[T];
};

template <const int T>
inline cache<T>::cache(){
	for(int i = 0; i < T; i++){
		reg_p[i] = new unsigned char(0);
	}
}


/*
	g	h	i
f	c	b	d
e	a	x
*/

template <const int T>
inline void cache<T>::get_a(unsigned char *x){
	*x = *reg_p[T/2];
}

template <const int T>
inline void cache<T>::get_b(unsigned char *x){
	*x = *reg_p[T/2+INDEX_OFFSET];
}

template <const int T>
inline void cache<T>::get_c(unsigned char *x){
	*x = *reg_p[T/2-1+INDEX_OFFSET];
}

template <const int T>
inline void cache<T>::get_d(unsigned char *x){
	*x = *reg_p[T/2+1+INDEX_OFFSET];
}
template <const int T>
inline void cache<T>::get_e(unsigned char *x){
	*x = *reg_p[T-3];
}
template <const int T>
inline void cache<T>::get_f(unsigned char *x){
	*x = *reg_p[T/2-2];
}
template <const int T>
inline void cache<T>::get_g(unsigned char *x){
	*x = *reg_p[0];
}
template <const int T>
inline void cache<T>::get_h(unsigned char *x){
	*x = *reg_p[1];
}
template <const int T>
inline void cache<T>::get_i(unsigned char *x){
	*x = *reg_p[2+INDEX_OFFSET];
}

template <const int T>
inline void cache<T>::get_x(unsigned char *x){
	*x = *reg_p[T-1];
}

template <const int T>
inline void cache<T>::write_x(unsigned char *x){
	*reg_p[T-1] = *x;
}

template <const int T>
inline void cache<T>::push(unsigned char *x){
	for(int i = 0; i < T-1; i++){
		*reg_p[i] = *reg_p[i+1];
	}
	*reg_p[T-1] = *x;
}

#endif //CACHE_H
