#ifndef CONTROL_DEC_H
#define CONTROL_DEC_H
#include <systemc.h>
#include "defs.h"
#include "if.h"

class ControlDec		:public sc_module
{
public:
	sc_out<bool> sinkRun;
	sc_out<bool> decRun[3];
	sc_out<bool> unpackRun;
	sc_in_clk clk;

	sc_event ev_start, ev_stop;
	int pixelCount;

	bool running;

	ControlDec(sc_module_name name)	: sc_module(name){
		SC_HAS_PROCESS(ControlDec);
		SC_THREAD(main);
			sensitive << clk.pos();
		SC_THREAD(counter);
			sensitive << clk.pos();

		running = 0;
		cout << this->name() << endl;
	}

	void newFrame(){
		if (running == 1){
			cout << "Error: (ControlDec) running\n";
			sc_stop();
		}
		ev_start.notify();
		running = 1;
		cout << "New frame (dec) " << endl;
	}
	void endFrame(){
		ev_stop.notify();
		running = 0;
	}
	void counter(){
		wait(ev_start);
		wait(9*CLK);
		while(pixelCount < PIC_SIZE_V*PIC_SIZE_H){
			pixelCount++;
			wait(CLK);
		}
		ev_stop.notify();
		running = 0;
		pixelCount = 0;
	}


	void main(){
		sinkRun->write(0);
		decRun[0]->write(0);
		decRun[1]->write(0);
		decRun[2]->write(0);
		unpackRun->write(0);

		wait(ev_start);
		wait(1 * CLK);
		unpackRun->write(1);
		wait(8 * CLK);
		decRun[0]->write(1);
		decRun[1]->write(1);
		decRun[2]->write(1);

		wait(20*CLK);
		sinkRun->write(1);

		wait(ev_stop);
		wait(2 * CLK);
		decRun[0]->write(0);
		decRun[1]->write(0);
		decRun[2]->write(0);
		wait(18*CLK);
		sinkRun->write(0);
		wait(100*CLK);
	}
};

#endif //CONTROL_H
