#ifndef DEFS_H
#define DEFS_H

#include <iostream>
#include <systemc.h>
#include <string>
using namespace std;

#ifndef max
#define max( a, b ) ( ((a) > (b)) ? (a) : (b) )
#endif

#ifndef min
#define min( a, b ) ( ((a) < (b)) ? (a) : (b) )
#endif

static const char INPUTFILE[] = "v1.bin";
static const char OUTPUTFILE[] = "v1.out.bin";
static const char INPUTPATH[] = "../../testbilder/";
static const char OUTPUTPATH[] = "../../testbilder/sc_RGB/v1/";



static const unsigned char ALPH_SIZE = 255;

static const sc_time CLK(20, SC_NS);
static const sc_clock C1("C1", CLK);

static const bool SPECTRAL_CORR = 1;
static const bool DECODE = 1;
static const int INDEX_OFFSET = 9;

static const int PACKET_SIZE = 259;
static const int HEADER_SIZE = 3;
static const int DATA_SIZE = PACKET_SIZE - HEADER_SIZE;
static const int SAMPLE_MAX_LENGTH = 16;

static const int PACK_MEM_SIZE = DATA_SIZE * 3;
static const int PACK_MIN_SIZE = DATA_SIZE / 8 - 1;
static const int SAMPLE_MAX_SIZE = DATA_SIZE * 2 - PACK_MIN_SIZE * 2 + 3; // 14/8 * PACKET_SIZE -1

static const int DEC_DATA_SIZE = 16;
static const int DEC_REG_SIZE = DEC_DATA_SIZE * 3;

static const int FIFO_IN_SIZE = 10;
static const int FIFO_OUT_SIZE = 30;
static const int FIFO_128_SIZE = 800;
static const int FIFO_126_SIZE = 20;

static const int PIC_SIZE_V = 1080;
static const int PIC_SIZE_H = 1920;
static const int PIC_SIZE = PIC_SIZE_V * PIC_SIZE_H;

static const int N0 = 32;

static const int CACHE_SIZE = 1920 * 2 + 2;

static const sc_time GOL_DEC_DELAY = 2 * CLK;
static const sc_time GOL_ENC_DELAY = 2 * CLK;
static const sc_time LOCO_K_DELAY = 2 * CLK;
static const sc_time LOCO_DELAY = 2 * CLK;



//DEBUG
static const int PIXEL = 17;
static const int PIXEL_TYPE = 2;

typedef struct ctxt_cache {
	int N[365];
	int D[365];
	int C[365];
	int A[365];
	int B[365];
} ctxt_cache;

class ctxt_info: public sc_int<32> {
public:
	ctxt_info() :
			sc_int<32>() {
	}
	int i;
	bool sign;
};

#include "sc_bv_var.h"
#include "stat.h"
#include "sc_lv_reg.h"
#include "cache.h"

#endif // DEFS_H
