#ifndef LOCO_H
#define LOCO_H
#include <systemc.h>
#include "defs.h"
#include "if.h"
class Loco: public sc_module {
public:
	sc_in<bool> run;
	sc_in<unsigned char> g_in;
	sc_port<fifo_read_if<unsigned char> > n_in;
	sc_port<sc_fifo_in_if<ctxt_info> > c_in;
	sc_out<unsigned char> g_out;
	sc_port<fifo_write_if<unsigned char> > n_out;
	sc_port<sc_fifo_in_if<bool> > unenc_in;
	sc_in_clk clk;

	Loco(sc_module_name, int, ctxt_cache*, cache<CACHE_SIZE>*, bool);
	void predict();
	void modeling();
	void adj_e();
	void next_pix();
	void new_frame();
	void delay_out();
	void start_mod();


private:
//	FILE *file;
	cache<CACHE_SIZE> * reg;
	bool encode;
	ctxt_cache * ctxt_reg;
	unsigned char A, B, C, D, E, F, G, H, I, X;
	unsigned char p, e_, e_temp;
	signed char e, temp_e;
	int x1, x2, x3;
	signed int g[3];
	signed int q[3];
	int type;
	sc_fifo<unsigned char> fifo_out;
	sc_fifo<char> fifo_mod;
	sc_fifo<ctxt_info> fifo_c;
	ctxt_info c_;
	ctxt_info temp_c;
	int pixelCount, pixelCountm;
	bool unenc;
	bool start_m;
	int temp_N, temp_B, temp_A, temp_C, temp_B2, temp_B3, temp_A2, temp_N2;
	sc_fifo<int> fifo_ctxt_A, fifo_ctxt_B, fifo_ctxt_N, fifo_ctxt_C;
};

#endif //LOCO_H
