#ifndef SC_LV_REG_H
#define SC_LV_REG_H

#include <systemc.h>

template < const int T >
class sc_lv_reg		: public sc_lv<T>{
public:
	sc_lv_reg();


	template < const int X >
	void add(sc_lv< X > *lv, int size){
		int avail = T - addIndex;
		if(size > 0){
			if (size > avail){
				this->range(T-1, addIndex) = lv->range(avail-1, 0);
			//	addIndex = 0;
				this->range(size-avail-1,0) = lv->range(size-1, avail);
				addIndex = size-avail;
			}
			else if(size == avail){
				this->range(T-1, addIndex) = *lv;
				addIndex = 0;
			}
			else{
				// endret til size-1
				this->range(addIndex+size-1, addIndex) = *lv;
				addIndex += size;
			}
		}
	}

	template<const int Y>
	void get(sc_lv<Y> *temp, int size){
		int avail = T - getIndex;
		if(size > 0){
			if (size > avail){
				temp->range(avail-1,0) = this->range(T-1, getIndex);
				temp->range(size-1, avail) = this->range(size-avail-1,0);
				getIndex = size-avail;
			}
			else if(size == avail){
				*temp = this->range(T-1, getIndex);
				getIndex = 0;
			}
			else{
				*temp = this->range(getIndex+size-1, getIndex);
				getIndex += size;
			}
		}
	}

	void setUnenc(){
		unencIndex = addIndex;
	}
	void setGetUnenc(){
		getIndex = unencIndex;
		unencIndex = T;
	}
	void clearUnenc(){
//		unencIndex = DEC_REG_SIZE;
		getIndex = (getIndex+5) % T;
	}


	bool checkUnenc(int i){
		if(unencIndex == 0){
			if(getIndex+i > T || getIndex == 0){
		//		cout << "bo1\n";
				return true;

			}
		}
		else if(unencIndex == T/2){
			if( (getIndex+i > T/2) && (getIndex <= T/2) ){
		//		cout << "bo2\n";
				return true;
			}
		}

		return false;

	}

	void reset(){
		addIndex = 0;
		getIndex = 0;
		unencIndex = T;
	}


//private:
	int unencIndex;
	int addIndex;
	int getIndex;
};
template < const int T >
sc_lv_reg<T>::sc_lv_reg(){
	sc_lv<T>();
	addIndex = 0;
	getIndex = 0;
	unencIndex = T;
}

#endif // SC_LV_REG_H
