#ifndef STREAM_H
#define STREAM_H
#include <systemc.h>
#include "defs.h"
#include "if.h"



class Source 	:public sc_module
{
public:
	sc_port < fifo_write_if<unsigned char> > writep_r, writep_g, writep_b;
	sc_port < sc_fifo_out_if<unsigned char> > tr_out, tg_out, tb_out;
	sc_in<bool> run;
	sc_in_clk clk;
	unsigned char R,G,B;
	char drop_data[54];
	FILE* f;

	Source (sc_module_name name) : sc_module (name)	{
		SC_HAS_PROCESS (Source);
		SC_THREAD(main);
		sensitive << run;

		char tempchar[30];
		sprintf(tempchar, "%s%s", INPUTPATH, INPUTFILE);
		f = fopen(tempchar, "rb");
//		fread(drop_data, sizeof(unsigned char), 54, f);
		cout << this->name() << endl;
	}

	void spectralRecode(unsigned char &R, unsigned char &G, unsigned char &B){
		R = (R-G);
		B = (B-G);
	}

	void main() {
		wait(CLK);
		while(true){
			if(run){
				// Read color components from bitmap data

				fread(&B, sizeof(unsigned char), 1, f);
				fread(&G, sizeof(unsigned char), 1, f);
				fread(&R, sizeof(unsigned char), 1, f);

				//Recode to R-G, G, B-G
				if(SPECTRAL_CORR) spectralRecode(R,G,B);

				// Write each color components to its own FIFO buffer
				writep_r->write(R);
				writep_g->write(G);
				writep_b->write(B);
	// Bypass original data:
	//			tr_out->write(R);
	//			tg_out->write(G);
	//			tb_out->write(B);
			}
			wait(CLK);
		}
	}

};

#endif // STREAM_H
