#ifndef UNPACK_H
#define UNPACK_H
#include <systemc.h>
#include "defs.h"
#include "if.h"

class Unpack		:public sc_module
{
public:


	sc_port<fifo_read_if<sc_lv<PACKET_SIZE> > > sourceP;
	sc_port<fifo_write_if<sc_lv<DATA_SIZE+1> > > sinkP[3];
	sc_in<bool> fifoReady;
	sc_in<bool> decReady[3];
	sc_in<bool> run;
	sc_bv<PACKET_SIZE> reg;
	sc_in_clk clk;


	int comp;

	Unpack(sc_module_name name) : sc_module(name){
		SC_HAS_PROCESS(Unpack);
		SC_THREAD(main);
			sensitive << clk.pos();
	}

	void main(){
		while(true){
			if(run && fifoReady){
				readMem();
				sinkP[comp]->write(reg.range(DATA_SIZE,0));
				wait(CLK);
			}
			else{
				wait(CLK);
			}
		}
	}


	void readMem(){
		reg = sourceP->read();
		if(reg.range(PACKET_SIZE-1,PACKET_SIZE-2) == "00"){
			comp = 0;
		}
		else if(reg.range(PACKET_SIZE-1,PACKET_SIZE-2) == "01"){
			comp = 1;
		}
		else if(reg.range(PACKET_SIZE-1,PACKET_SIZE-2) == "10"){
			comp = 2;
		}
		else{
			cout << this->name();
			sc_stop();
		}
	}
};



#endif //UNPACK_H
