library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity find_k is
	port(
		clk        : in  std_logic;
		rst        : in  std_logic;
		A          : in  std_logic_vector(A_LEN - 1 downto 0);
		N          : in  std_logic_vector(N_LEN - 1 downto 0);
		k_out      : out std_logic_vector(8 downto 0);
		k_less_out : out std_logic_vector(8 downto 0);
		k_int_out  : out std_logic_vector(3 downto 0)
	);
end entity find_k;

architecture RTL of find_k is
	signal N_ctxt : std_logic_vector(N_LEN - 1 downto 0);
	signal A_ctxt : std_logic_vector(A_LEN - 1 downto 0);
begin
	comp_k : process(clk, rst) is
	begin
		if rising_edge(clk) then
			if rst = '1' then
				k_out      <= "100000000";
				k_less_out <= "011111111";
				k_int_out  <= "1000";
				A_ctxt     <= (others => '1');
				N_ctxt     <= (others => '0');

			--Select k based on A and N:
			else
				A_ctxt <= A;
				N_ctxt <= N;
				-- k = 0
				if "00000000" & N_ctxt >= A_ctxt then
					k_out      <= "000000001";
					k_less_out <= "000000000";
					k_int_out  <= "0000";
				-- k = 1
				elsif "0000000" & N_ctxt & "0" > A_ctxt then
					k_out      <= "000000010";
					k_less_out <= "000000001";
					k_int_out  <= "0001";
				-- k = 2
				elsif "000000" & N_ctxt & "00" > A_ctxt then
					k_out      <= "000000100";
					k_less_out <= "000000011";
					k_int_out  <= "0010";
				-- k = 3
				elsif "00000" & N_ctxt & "000" > A_ctxt then
					k_out      <= "000001000";
					k_less_out <= "000000111";
					k_int_out  <= "0011";
				-- k = 4
				elsif "0000" & N_ctxt & "0000" > A_ctxt then
					k_out      <= "000010000";
					k_less_out <= "000001111";
					k_int_out  <= "0100";
				-- k = 5
				elsif "000" & N_ctxt & "00000" > A_ctxt then
					k_out      <= "000100000";
					k_less_out <= "000011111";
					k_int_out  <= "0101";
				-- k = 6
				elsif "00" & N_ctxt & "000000" > A_ctxt then
					k_out      <= "001000000";
					k_less_out <= "000111111";
					k_int_out  <= "0110";
				-- k = 7
				elsif "0" & N_ctxt & "0000000" > A_ctxt then
					k_out      <= "010000000";
					k_less_out <= "001111111";
					k_int_out  <= "0111";
				-- k = 8
				else
					k_out      <= "100000000";
					k_less_out <= "011111111";
					k_int_out  <= "1000";
				end if;
			end if;
		end if;
	end process comp_k;
end architecture RTL;
