library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity update_registers is
	port(
		clk       : in  std_logic;
		k_in      : in  std_logic_vector(3 downto 0);
		k_in_bit  : in  std_logic_vector(8 downto 0);
		get_in    : in  std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		data_in   : in  std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		end_q_out : out std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		get_out   : out std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		k_out     : out std_logic_vector(3 downto 0)
	);
end entity update_registers;

-- Top module for golomb index registers and counter:
architecture RTL of update_registers is
	signal end_q : std_logic_vector(DEC_REG_SIZE - 1 downto 0);
	signal k8    : std_logic;
begin
	end_q_out <= end_q;
	find_end_q_module : entity work.find_end_q port map(
			clk       => clk,
			end_q     => end_q,
			get_in_in => get_in,
			data_in   => data_in
		);
	k8_module : entity work.k8 port map(
			clk      => clk,
			get_in   => get_in,
			end_q_in => end_q,
			k8       => k8
		);
	find_end_r_module : entity work.find_end_r port map(
			clk      => clk,
			end_q    => end_q,
			k8       => k8,
			get_out  => get_out,
			k_in     => k_in,
			k_in_bit => k_in_bit,
			k_out    => k_out
		);
end architecture RTL;
