library ieee;
use ieee.std_logic_1164.all;
use ieee.STD_LOGIC_ARITH.ALL;
use ieee.std_logic_unsigned.all;
use work.defs.all;

entity gol_enc_shift is
	port(
		clk : in  std_logic;
		rst : in  std_logic;
		k   : in  std_logic_vector(8 downto 0);
		O   : out std_logic_vector(SMPL_LEN - 1 downto 0);
		I   : in  std_logic_vector(SMPL_LEN - 1 downto 0)
	);
end gol_enc_shift;
architecture arch of gol_enc_shift is
begin
	process(clk) is
	begin
	-- Shift input based on k = 0 ... 8:
		if rising_edge(clk) then
				if k = "000000001" then
					O <= I(7 downto 0);
				elsif k = "000000010" then
					O <= "0" & I(7 downto 1);
				elsif k = "000000100" then
					O <= "00" & I(7 downto 2);
				elsif k = "000001000" then
					O <= "000" & I(7 downto 3);
				elsif k = "000010000" then
					O <= "0000" & I(7 downto 4);
				elsif k = "000100000" then
					O <= "00000" & I(7 downto 5);
				elsif k = "001000000" then
					O <= "000000" & I(7 downto 6);
				elsif k = "010000000" then
					O <= "0000000" & I(7 downto 7);
				elsif k = "100000000" then
					O <= "00000000";
				end if;
			end if;
	end process;
end arch;