library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity comb_qr is
	port(
		clk      : in  std_logic;
		rst      : in  std_logic;
		q        : in  std_logic_vector(2 downto 0);
		r        : in  std_logic_vector(7 downto 0);
		k        : in  std_logic_vector(3 downto 0);
		data_out : out std_logic_vector(7 downto 0)
	);
end entity comb_qr;

architecture RTL of comb_qr is
	function rev_lv(a : in std_logic_vector) return std_logic_vector is
		variable result : std_logic_vector(a'RANGE);
		alias aa        : std_logic_vector(a'REVERSE_RANGE) is a;
	begin
		for i in aa'RANGE loop
			result(i) := aa(i);
		end loop;
		return result;
	end;                                -- function reverse_any_vector
begin
	qr : process(clk) is
	begin
		if rising_edge(clk) then
			if rst = '1' then
				data_out <= (others => '0');
			else
				if k = 0 then
					data_out <= "00000" & q;
				elsif k = 1 then
					data_out <= "0000" & q & r(0);
				elsif k = 2 then
					data_out <= "000" & q & rev_lv(r(1 downto 0));
				elsif k = 3 then
					data_out <= "00" & q & rev_lv(r(2 downto 0));
				elsif k = 4 then
					data_out <= "0" & q & rev_lv(r(3 downto 0));
				elsif k = 5 then
					data_out <= q & rev_lv(r(4 downto 0));
				elsif k = 6 then
					data_out <= q(1 downto 0) & rev_lv(r(5 downto 0));
				elsif k = 7 then
					data_out <= q(0) & rev_lv(r(6 downto 0));
				else
					data_out <= rev_lv(r);
				end if;
			end if;
		end if;
	end process qr;
end architecture RTL;
