library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity count_q is
	port(
		clk   : in std_logic;
		get   : in std_logic;
		data  : in std_logic_vector(7 downto 0);
		end_q : buffer std_logic_vector(7 downto 0)
	);
end entity count_q;

architecture RTL of count_q is
	type q_arr is array (0 to 7) of std_logic;
	signal q : q_arr;

begin
	q(1)     <= data(0) and get;
	end_q(0) <= not data(0) and get;
	n_dec_reg : for n in 1 to 6 generate
		q((n + 1) mod 8) <= data(n) and q(n);
		end_q(n)         <= not data(n) and q(n);
	end generate;
	end_q(7) <= not data(7) and q(7);
end architecture RTL;
