library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity data_in_reg is
	port(
		clk      : in  std_logic;
		rst      : in  std_logic;
		data_in  : in  std_logic_vector(DATA_IN_REG_SIZE - 1 downto 0);
		ready_in : in  std_logic_vector(DATA_IN_REG_NUM - 1 downto 0);
		data_out : out std_logic_vector(DEC_REG_SIZE - 1 downto 0)
	);
end entity data_in_reg;

architecture RTL of data_in_reg is
	type data_arr is array (0 to DATA_IN_REG_NUM - 1) of std_logic_vector(DATA_IN_REG_SIZE - 1 downto 0);
	signal data_reg : data_arr;
begin
	clocked : process(clk, data_reg) is
	begin
		for n in 1 to DATA_IN_REG_NUM loop
			data_out(DATA_IN_REG_SIZE * n - 1 downto DATA_IN_REG_SIZE * (n - 1)) <= data_reg(n - 1);
		end loop;
	end process clocked;

	name : process(clk) is
	begin
		if rising_edge(clk) then
			if rst = '1' then
				for n in 0 to DATA_IN_REG_NUM - 1 loop
					data_reg(n) <= "1111111101111111";
				end loop;
			else
				for n in 0 to DATA_IN_REG_NUM - 1 loop
					if ready_in(n) = '1' then
						data_reg(n) <= data_in;
					else
						data_reg(n) <= data_reg(n);
					end if;
				end loop;
			end if;
		end if;
	end process name;
end architecture RTL;
