library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity decode_r is
	port(
		clk      : in  std_logic;
		rst      : in  std_logic;
		end_q_in : in  std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		data_in  : in  std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		data_out : out std_logic_vector(7 downto 0)
	);
end entity decode_r;

architecture RTL of decode_r is
	type data_arr is array (DEC_REG_SIZE - 1 downto 0) of std_logic_vector(7 downto 0);
	signal data : data_arr;

begin
	r_MUX_array0 : for i in 7 downto 0 generate
		r_MUX_array1 : for j in DEC_REG_SIZE - 2 downto 0 generate
			r_MUXs : entity work.decode_r_mux port map(
					clk       => clk,
					data_in   => data_in(j),
					active    => end_q_in((j - i - 1) mod DEC_REG_SIZE),
					data_out  => data(j)(i),
					prev_data => data(j + 1)(i)
				);
		end generate;
		r_MUX : entity work.decode_r_mux port map(
				clk       => clk,
				data_in   => data_in(DEC_REG_SIZE-1),
				active    => end_q_in((DEC_REG_SIZE-1 - i - 1) mod DEC_REG_SIZE),
				data_out  => data(DEC_REG_SIZE-1)(i),
				prev_data => '0'
			);
	end generate;
	data_out <= data(0);
end architecture RTL;
