library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity decode_r_mux is
	port(
		clk       : in  std_logic;
		data_in   : in  std_logic;
		prev_data : in  std_logic;
		active    : in  std_logic;
		data_out  : out std_logic
	);
end entity decode_r_mux;

architecture RTL of decode_r_mux is
begin
	comb : process(data_in, prev_data, active) is
	begin
		if active = '1' then
			data_out <= data_in;
		else
			data_out <= prev_data;
		end if;
	end process comb;
end architecture RTL;
