library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

entity find_end_r is
	port(
		clk      : in  std_logic;
		end_q    : in  std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		k8       : in  std_logic;
		get_out  : out std_logic_vector(DEC_REG_SIZE - 1 downto 0);
		k_out    : out std_logic_vector(3 downto 0)
	);
end entity find_end_r;

architecture RTL of find_end_r is
	type end_r_arr is array (1 downto 0) of std_logic_vector(DEC_REG_SIZE - 1 downto 0);
	signal end_r : end_r_arr;

begin
--	end_r(2) <= end_q(DEC_REG_SIZE - 4 downto 0) & end_q(DEC_REG_SIZE - 1 downto DEC_REG_SIZE - 3); -- k = 2
	end_r(0) <= end_q(DEC_REG_SIZE - (K_INT+2) downto 0) & end_q(DEC_REG_SIZE - 1 downto DEC_REG_SIZE - (K_INT+1)); -- k = 3
	end_r(1) <= end_q(DEC_REG_SIZE - 10 downto 0) & end_q(DEC_REG_SIZE - 1 downto DEC_REG_SIZE - 9);

	get_out_proc : process(clk, end_r, k8) is
	begin
		if k8 = '1' then
			get_out <= end_r(0);
			k_out <= K;
		else
			get_out <= end_r(1);
			k_out   <= "1000";
		end if;
	end process;
end architecture RTL;
