library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.defs.all;

ENTITY line_cache IS
	PORT(
		clk        : IN  STD_LOGIC;
		shift      : IN  STD_LOGIC;
		write_0    : in  std_logic;
		sr_in      : IN  STD_LOGIC_VECTOR(SMPL_LEN - 1 DOWNTO 0);
		sr_tap_B_l : OUT STD_LOGIC_VECTOR(SMPL_LEN - 1 DOWNTO 0)
	);
END line_cache;

ARCHITECTURE arch OF line_cache IS
	--	SUBTYPE sr_width IS STD_LOGIC_VECTOR(SMPL_LEN-1 DOWNTO 0);
	TYPE sr_length IS ARRAY (CACHE_SIZE - 1 DOWNTO 0) OF STD_LOGIC_VECTOR(SMPL_LEN - 1 DOWNTO 0);

	SIGNAL sr : sr_length;

	signal data : STD_LOGIC_VECTOR(SMPL_LEN - 1 DOWNTO 0);

BEGIN
	write0 : process(sr_in, write_0) is
	begin
		if write_0 = '1' then
			data <= (others => '0');
		else
			data <= sr_in;
		end if;
	end process write0;

	PROCESS(clk)
	BEGIN
		IF (clk'EVENT and clk = '1') THEN
			IF (shift = '1') THEN
				sr(CACHE_SIZE - 1 DOWNTO 1) <= sr(CACHE_SIZE - 2 DOWNTO 0);
				sr(0)                       <= data;
			END IF;
		END IF;
	END PROCESS;
	sr_tap_B_l <= sr(CACHE_SIZE - 1);
END arch;
