library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
package defs is

	-- DEFINITIONS
	---------------------------------------------------------------------------------
	constant A_LEN            : integer := 13;
	constant B_LEN            : integer := 6;
	constant C_LEN            : integer := 9;
	constant N_LEN            : integer := 6;
	constant CTXT_INDEX_RANGE : integer := 256;
	constant CTXT_ADDR_SIZE   : integer := 8;
	constant SMPL_LEN         : integer := 8;
	constant GOL_MAX_LEN      : integer := 16;
	constant DEC_REG_SIZE     : integer := 48;
	constant DEC_REG_LEN      : integer := 6;
	constant DATA_IN_REG_SIZE : integer := 16;
	constant DATA_IN_REG_NUM  : integer := 3;

	constant CACHE_SIZE         : integer := 1917;
	constant CACHE_INDEX_OFFSET : integer := 10;

	constant ENC_K_DELAY     : integer := 5;
	constant ENC_INDEX_DELAY : integer := 11;
	constant ENC_SIGN_DELAY  : integer := 5;

	constant ENC_INDEX_RST  : integer := 1;
	constant ENC_K_RST      : integer := 5;
	constant ENC_LOCO_RST   : integer := 11;
	constant ENC_LOCO_W_RST : integer := 13;
	constant ENC_GOL_RST    : integer := 14;

	constant DEC_K_DELAY     : integer := 2;
	constant DEC_INDEX_DELAY : integer := 11;
	constant DEC_SIGN_DELAY  : integer := 5;

	constant DEC_INDEX_RST  : integer := 1;
	constant DEC_K_RST      : integer := 5;
	constant DEC_LOCO_RST   : integer := 11;
	constant DEC_LOCO_W_RST : integer := 13;
	constant DEC_GOL_RST    : integer := 5;

	constant K     : std_logic_vector(3 downto 0) := "0001";
	constant K_INT : integer                      := 1;
end defs;