#ifndef CODEC_H
#define CODEC_H

#include "def.h"


int predict(pix *P, int k, enum CODEC c) {
	switch (c) {
	case B:
		return P->b->RGB[k];
	case C:
		return P->c->RGB[k];
	case D:
		return P->d->RGB[k];
	case BC:
		return (P->b->RGB[k] + P->c->RGB[k]) / 2;
	case BD:
		return (P->d->RGB[k] + P->b->RGB[k]) / 2;
	case CBD:
		return (int)((double)(P->d->RGB[k] + P->c->RGB[k] + P->b->RGB[k]) /(double)3);
	}
}

void cM_init(cMod * cM) {
	int ii, jj;
	for (ii = 0; ii < 3; ii++) {
		for (jj = 0; jj < 365; jj++) {
			cM->N[ii][jj] = 0;
			cM->C[ii][jj] = 0;
			cM->A[ii][jj] = 0;
			cM->B[ii][jj] = 0;
			cM->golombCount = 0;
			cM->maxMk = 0;
			cM->maxA = 0;
			cM->maxB = 0;
			cM->maxC = 0;
			cM->maxN = 0;
		}
	}
}

#endif // CODEC_H
