#ifndef DEF_H
#define DEF_H


#include <iostream>
#include <fstream>
#include <algorithm>
#include <stdio.h>
#include <cmath>
#include <vector>
#include <limits.h>
#include <string>
#include <sstream>

using namespace std;

// Constants
static const int ALPHABET_SIZE = 256;
static const int SS1 = 1080;
static const int SS2 = 1920;
static const int SS3 = 3;
static const int FRAMES = 1;
static const int N0 = 32;
static const int FIXED_GOLOMB = 0;

enum CODEC {
	B, C, D, BC, BD, CBD, ADAPTIVE, CODEC_NUM
};

static const int minV(int v[], int s) {
	int m = v[0];
	int c = 0;
	for (int i = 1; i < s; i++) {
		if (v[i] < m) {
			c = i;
			m = v[i];
		}
	}
	return c;
}
static const int mod(int a, int b) {
	int c = a % b;
	return (c < 0) ? c + b : c;
}

static const char *cCODEC[] = { "B", "C", "D", "BC", "BD", "CBD", "ADAPT" };

typedef struct entropyTableType {
	int t[CODEC_NUM][ALPHABET_SIZE];
} entTab;

typedef struct contextModelingType {
	short N[3][365];
	short C[3][365];
	short A[3][365];
	short B[3][365];
	int golombCount;
	int maxMk;
	int maxG;
	int maxA;
	int maxB;
	int maxC;
	int maxN;
} cMod;

// Pixel structure of image array
typedef struct pixelType {
	unsigned char RGB[3];
	unsigned char YUV[3];
	struct pixelType* a;
	struct pixelType* b;
	struct pixelType* c;
	struct pixelType* d;
	struct pixelType* i;
} pix;

// Structure of processed pixel
typedef struct procPixelType {
	short E[3];
	short E_noCtxt_temp[3];
	unsigned char E_noCtxt[3];
	short RGB[3];
	short X1[3];
	short X2[3];
	unsigned char E_u8[3];
	signed char E_s8[3];
	int index[3];
	int sign[3];
} pixBuffer;


#endif //DEF_H
