#include "entropy.h"


using namespace std;

Entropy::Entropy() {
}
;

void Entropy::entInit(enum CODEC c) {
	int i;
	for (i = 0; i < ALPHABET_SIZE; i++) {
		t[c][i] = 0;
	}
}

void Entropy::entAdd(enum CODEC c, int i) {
	t[c][i]++;
}

int Entropy::entSum(enum CODEC c) {
	int i, sum;
	sum = 0;
	for (i = 0; i < ALPHABET_SIZE; i++) {
		sum += t[c][i];
	}
	return sum;
}

double Entropy::entCompute(enum CODEC c) {
	float H, temp;
	int i, sum;
	H = 0;
	sum = entSum(c);
	for (i = 0; i < ALPHABET_SIZE; i++) {
		if (t[c][i] != 0) {
			temp = (double) t[c][i] / (double) sum;
			H -= (temp * (log(temp) / log(2)));
		}
	}
	return H;
}

