#ifndef IMAGEARRAY_H
#define IMAGEARRAY_H

#include "def.h"

class ImgArray {
public:
	ImgArray(const char* fileName);
	~ImgArray();
	void buildArray();
	pix read(int line, int col);
	pix* getLine(int);
	void write(int line, int col, pix p);
	void writeValue(int line, int col, int cnl, int value);
	void preProcess();
	void postProcess();
private:
	pix *P;
	pix *startP;
	pix zeroP;
};

ImgArray::ImgArray(const char* fileName) {
	P = new pix[SS1 * SS2];
	pix *itP = P;

	zeroP.RGB[0] = 0;
	zeroP.RGB[1] = 0;
	zeroP.RGB[2] = 0;

	FILE * file;
	file = fopen(fileName, "r");

	for (int i = 0; i < SS1; i++) {
		for (int j = 0; j < SS2; j++) {
			fread(&(itP->RGB), 1, 3, file);
			//		itP->RGB[0] = 255;
			//		itP->RGB[1] = 255;
			//		itP->RGB[2] = 255;
			if (i == 0 && j == 0) {
				itP->a = &zeroP;
				itP->b = &zeroP;
				itP->c = &zeroP;
				itP->d = &zeroP;
				itP->i = &zeroP;
			} else if (i == 0) {
				itP->a = itP - 1;
				itP->b = &zeroP;
				itP->c = &zeroP;
				itP->d = &zeroP;
				itP->i = &zeroP;
			} else if (i == 1 && j == 0) {
				itP->a = itP - 1;
				itP->b = itP - SS2;
				itP->c = &zeroP;
				itP->d = itP - (SS2 - 1);
				itP->i = &zeroP;
			} else if (i == 1) {
				itP->a = itP - 1;
				itP->b = itP - SS2;
				itP->c = itP - (SS2 + 1);
				itP->d = itP - (SS2 - 1);
				itP->i = &zeroP;

			/*} else if (j == 0) {
				itP->a = &zeroP;
				itP->b = itP - SS2;
				itP->c = &zeroP;
				itP->d = itP - (SS2 - 1);
				itP->i = itP - (SS2*2);*/
			} else {
				itP->a = itP - 1;
				itP->b = itP - SS2;
				itP->c = itP - (SS2 + 1);
				itP->d = itP - (SS2 - 1);
				itP->i = itP - (SS2*2);
			}
			itP++;
		}
	}
	fclose(file);
}

ImgArray::~ImgArray() {
	delete P;
}

pix ImgArray::read(int line, int col) {
	return this->P[SS2 * line + col];
}

pix* ImgArray::getLine(int line) {
	return &this->P[SS2 * line];
}
void ImgArray::write(int line, int col, pix p) {
	this->P[SS2 * line + col] = p;
}

void ImgArray::writeValue(int line, int col, int cnl, int value) {
	this->P[SS2 * line + col].RGB[cnl] = value;
}

void ImgArray::preProcess() {
	for (int i = 0; i < SS1; i++) {
		for (int j = 0; j < SS2; j++) {
			P[SS2 * i + j].RGB[0] = mod(
					(int) P[SS2 * i + j].RGB[0] - (int) P[SS2 * i + j].RGB[1]
							+ 128, 256);
			P[SS2 * i + j].RGB[2] = mod(
					(int) P[SS2 * i + j].RGB[2] - (int) P[SS2 * i + j].RGB[1]
							+ 128, 256);
		}
	}
}

void ImgArray::postProcess() {
	for (int i = 0; i < SS1; i++) {
		for (int j = 0; j < SS2; j++) {
			P[SS2 * i + j].RGB[0] = mod(
					(int) P[SS2 * i + j].RGB[0] + (int) P[SS2 * i + j].RGB[1]
							+ 128, 256);
			P[SS2 * i + j].RGB[2] = mod(
					(int) P[SS2 * i + j].RGB[2] + (int) P[SS2 * i + j].RGB[1]
							+ 128, 256);
		}
	}
}
#endif //IMAGEARRAY
