#include "def.h"
#include "line.h"
#include "imgArray.h"
#include "felics.h"
#include "entropy.h"
#include "codec.h"
#include "adaptiveList.h"

//SET IMAGE INPUT/OUTPUT IN DEF.H

int main() {

	// Declarations
	Line *L[CODEC_NUM];
	FILE *file1;
	ImgArray *I;

	// Adaptive list
	AdaptiveList* adL;
	adL = new AdaptiveList;

	// Init modeling and entropy table
	cMod *cM[CODEC_NUM];
	Entropy *tab;
	tab = new Entropy[2];
	for (int i = 0; i < CODEC_NUM; i++) {
		cM[i] = new cMod;
		cM_init(cM[i]);
		tab[0].entInit((enum CODEC) i);
		tab[1].entInit((enum CODEC) i);
	}

	cout << endl << endl;

	string fn;
	fn = "../../Testbilder/v1.bin";

	for (int f = 0; f < FRAMES; f++) {
//		FIXED_GOLOMB = (int)floor((double)f/6) + 6;

		fn[18] = 49 + f % FRAMES;
		for (int i = 0; i < CODEC_NUM; i++) {
			cM_init(cM[i]);
			tab[0].entInit((enum CODEC) i);
			tab[1].entInit((enum CODEC) i);
		}
		adL->clear();

		// Load input image
		const char * charfn = fn.c_str();

		cout << endl << charfn << endl;
		I = new ImgArray(charfn);
		I->preProcess();

		cout << "Fixed Golomb: " << FIXED_GOLOMB << endl << endl;

//JPEG-LS:
		cout << endl << "JPEG-LS" << endl;
		for (int i = 0; i < SS1; i++) {

			for (int cc = 0; cc < 1; cc++) {

				L[cc] = new Line(I, cM[cc], tab, adL, (enum CODEC) cc, i,
						"fjernes", 1);
				L[cc]->run();

				delete L[cc];
			}
		}

		cout << "Codec\tEntCtx\tGolomb\tEnt";
		cout << "\tMax A\tMax B\tMax C\tMax N\tMax G";
		cout << endl;
		for (int cc = 0; cc < 1; cc++) {

			cout << cCODEC[cc] << "\t";
			cout << tab[0].entCompute((enum CODEC) cc) << "\t";
			cout << (double) cM[cc]->golombCount / (SS1 * SS2 * SS3 * (1))
					<< "\t";
			cout << tab[1].entCompute((enum CODEC) cc) << "\t";
			cout << cM[cc]->maxA << "\t" << cM[cc]->maxB << "\t" << cM[cc]->maxC
					<< "\t" << cM[cc]->maxN << "\t" << cM[cc]->maxG;
			cout << endl;
		}
		cout << endl;

		delete I;

	}

	cout << "done encode" << endl;

	//Decode:
	bool decode = 0;
	if (decode == 1) {
		ImgArray *pO[CODEC_NUM];
		for (int i = 0; i < CODEC_NUM; i++) {
			pO[i] = new ImgArray(".ctxt.PNG1.enc");
			cM_init(cM[i]);
		}

		file1 = fopen("decoded", "w");
		for (int i = 0; i < SS1; i++) {
			for (int cc = 0; cc < CODEC_NUM; cc++) {
				L[cc] = new Line(pO[cc], cM[cc], tab, adL, (enum CODEC) cc, i,
						"decoded", 0);
				L[cc]->run();
				delete L[cc];
			}
		}
		pO[1]->postProcess();
		for (int ii = 0; ii < SS1; ii++) {
			for (int jj = 0; jj < SS2; jj++) {
				fwrite(pO[1]->read(ii, jj).RGB, 1, 3, file1);
			}
		}
		fclose(file1);
	}

}

